/*
 *  CERN utilities.
 */
extern char* makeword( char* line, char stop );
extern char* fmakeword( FILE* f, char stop, int* len );
extern char x2c( char* what );
extern void unescape_url( char* url );
extern void plustospace( char* str );

/*
 *  My own local utilities.
 */
#define MAX_ENTRIES 10000

typedef long int ulong;

typedef struct
{
   char* name;
   char* val;
} entry;

extern void PrintText( char* ss[] );
extern ulong SetBit( ulong m, int i );
extern ulong ClrBit( ulong m, int i );
extern ulong pow2( int p );
extern int root2( ulong i );
extern void lowercase( char* s );
extern int stringIndex( char* s, char* ss[] );
extern int CGIInit( entry entries[] );
extern char* CommaNumber( ulong i );
extern void ParseArg( int *first, int *maxhits, int *m, char* arg,
       entry entries[] );

/*
 *  My database engine.
 */

#include <sys/time.h>
#define BF buf+strlen(buf)

typedef enum
{ C_NONE=0, C_EQ=1, C_NE=2, C_LT=3, C_LE=4, C_GT=5, C_GE=6 }
DBCompar;

typedef enum { MASK, STRING, DATE, NUMBER, BOOL, LOOKUP, LAST } DBType;

typedef struct {
   DBType type;
   char *name;
} DBField;

typedef struct {
   char *field;
   char **values;
} DBMask;

extern long int dbTotalSeconds;	/* # seconds to compute and send hits */
extern long int dbTotalBIn;	/* # bytes read */
extern long int dbTotalBOut;	/* # bytes sent (hits only) */

extern int dbRecord( char* s );
extern int dbQuery( char* s );
extern int dbUpdateQuery( char* field, char* val, DBField f[], DBMask m[] );
extern int dbSetAndOr( char* field, char* val, DBField f[] );
extern int dbSetCompar( char* field, char* val, DBField f[] );
extern int dbFilter( void );
extern int dbFilterI( int i );
extern int dbWrite( int record );
extern int dbValue( int field, char* buf );
extern int dbSchemaT( DBField sch[] );
extern int dbSchemaC( int argc, char *argv[] );
extern int dbMaskIndex( char* mask, char* masks[] );
extern int dbDumpHits( FILE* fp, int first, int maxhits, int* next,
       int (*filter)(), void (*print)() );
extern void dbNextAnchor( char *url, int first, int maxhits, entry entries[],
       int m );
