#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/time.h>

#include "../libweb/webutil.h"
#include "food.h"
#include "restaura.h"

/*----------------------------------------------------------------------------*/

static char* LandMark( char *s )
{
   static char buf[128];
   if( strcmp( s, "" ) == 0 ) return( "" );
   else
   {
      sprintf( buf, "<I>%s</I>, ", s );
      return( buf );
   }
}

static char* Review( char *s )
{
   static char buf[512];
   if( strcmp( s, "" ) == 0 ) return( "" );
   else
   {
      sprintf( buf, " (<FONT SIZE=\"-1\"><A HREF=\"%s/%s\">Toronto Life review</A></FONT>)",
               TOR_LIFE_DB_PATH, s );
      return( buf );
   }
}

/*----------------------------------------------------------------------------*/

static int myFilter( void )
{
   return ( dbFilterI(0) > -1 &&
            dbFilterI(1) > -1 &&
            dbFilterI(2) > -1 &&
            ( dbFilterI(3) + dbFilterI(4) ) > -1 &&
            dbFilterI(7) > -1 &&
            dbFilterI(8) > -1
          ) ? 1 : 0;
}

/*----------------------------------------------------------------------------*/

static void DumpRecord( int n, char* buf )
{
   sprintf( buf, HTML_FMT, f_name, f_addr, LandMark( f_landmark ),
   cityBits[atoi(f_city)], f_tel, Review( f_torlife ), 10 );
}

/*----------------------------------------------------------------------------*/

static int BuildQuery( entry entries[], int m )
{
   int x, n = 0;

  /*
   *  First, set up schema and initialize query.
   */
   dbSchemaT( fields );
   dbQuery( "|||0|0|0||0|0|" );

  /*
   *  Next, build query using form input values.
   */
   for( x = 0; x <= m; x++ )
   {
      if( strcmp( entries[x].name, "" ) && strcmp( entries[x].val, "" ) )
      {
         if( dbUpdateQuery( entries[x].name, entries[x].val, fields, masks ) )
         {
            n++;
         }
         else
         {
            if( strcmp( entries[x].name, "typeAnd" ) == 0 )
            {
               dbSetAndOr( "type", entries[x].val, fields );
            }
         }
      }
   }

   return n;
}

/*----------------------------------------------------------------------------*/

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   int empty_query, m = CGIInit( entries );

   printf( "Content-type: text/html%c%c", 10, 10 );
   printf( "<header>%c", 10 );
   printf(
   "<title>Toronto's WWW Restaurant Listings - Query Results</title>%c", 10 );
   printf( "</header>%c", 10 );
   printf( "<body background=\"/images/bg.jpg\">%c", 10 );
   printf( "<h2>Query Results</h2>%c<hr>", 10 );

   empty_query = (BuildQuery( entries, m ) == 0);

   if( ! empty_query )
   {
      char path[256];
      FILE* fp;
      int n, next;

      sprintf( path, "%s/%s/lib/restaura.txt", ROOT, CLIENT );
      fp = fopen( path, "r" );
      n = dbDumpHits( fp, 0, 999999999, &next, &myFilter, &DumpRecord );
      fclose( fp );

      printf( "<p><hr><i>Query generated " );
      printf( "<b>%s</b> hits and took ", CommaNumber(n) );
      printf( "<b>%s</b> seconds to scan ", CommaNumber(dbTotalSeconds) );
      printf( "<b>%s</b> bytes of data and to send ", CommaNumber(dbTotalBIn) );
      printf( "<b>%s</b> bytes of results.</i>%c", CommaNumber(dbTotalBOut),
      10 );
      printf( SIG );
      printf( "</body>%c", 10 );
   }
   else
   {
      printf(
      "You did not select any search criteria.  Please try again.<br>%c", 10 );
      printf( SIG );
      printf( "</body>%c", 10 );
   }
   return 0;
}

/*----------------------------------------------------------------------------*/
