/*
 *   db.c  - simple database engine.
 *   Copyright (C) 1995, by Emanuel G. Noik
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "webutil.h"
#include "db++.h"

/*---------------------------------------------------------------------------*/

dbEngine engine;

/*---------------------------------------------------------------------------*/

/*
int dbUpdateQuery( char* name, char* val, DBField fields[], DBMask masks[] )
{
   int f = FindField( name, fields );

   if( f == -1 ) return 0;

   switch( fields[f].type )
   {
      case MASK:
         if( strtol( val, 0, 0 ) != 0 )
            query[f].v.m.i += strtol( val, 0, 0 );
         else
         {
            int m, found = 0;
            for( m = 0; masks[m].field; m++ )
            {
               if( strcmp( name, masks[m].field ) == 0 )
               {
                  found = 1;
                  break;
               }
            }
            if( found )
            {
               int t;
               if( (t = stringIndex( val, masks[m].values )) != -1 )
                  query[f].v.m.i += pow2( t );
               else return 0;
            }
            else return 0;
         }
         break;
      case STRING:
         lowercase( val );
         sprintf( query[f].v.s, "%s", val );
         break;
      case DATE:
         sscanf( val, "%d/%d/%d", &query[f].v.d.m, &query[f].v.d.d,
            &query[f].v.d.y );
         break;
      case BOOL:
         sscanf( val, "%d", &query[f].v.b );
         break;
      case LOOKUP:
         if( val[0] == '0' || atoi( val ) != 0 )
            query[f].v.l.values[query[f].v.l.length++] = atoi( val );
         else
         {
            int m, found = 0;
            for( m = 0; masks[m].field; m++ )
            {
               if( strcmp( name, masks[m].field ) == 0 )
               {
                  found = 1;
                  break;
               }
            }
            if( found )
            {
               int t;
               if( (t = stringIndex( val, masks[m].values )) != -1 )
                  query[f].v.l.values[query[f].v.l.length++] = t;
               else return 0;
            }
            else return 0;
         }
         break;
      default:
         break;
   }
   return 1;
}
*/

/*---------------------------------------------------------------------------*/

#define BUFSIZE 4096	/* EGN: be careful about this limit */

int dbDumpHits( FILE* fp, int first, int maxhits, int* next,
int (*filter)(), void (*print)(int,char*) )
{
   char buf[BUFSIZE];
   int i, n = 0;
   struct timeval finish, start;
   struct timezone tz;

   engine.bytesIn = 0;
   engine.bytesOut = 0;  
   gettimeofday( &start, &tz );

   /* move to first record */
   for( i = 0; i < first; i++ )
      if( fgets( buf, BUFSIZE-10, fp ) == 0 )
      {
         *next = 0;
         goto end;
      }

   for( ; ; i++ )
   {
      if( fgets( buf, BUFSIZE-10, fp ) == 0 )
      {
         *next = 0;
         break;
      }

      engine.ClearRecord( 0 );
      engine.SetRecord( buf, 0 );
      engine.bytesIn += strlen( buf );
      buf[0] = 0;

      if( filter ? filter() : engine.Filter() )
      {
         if( n < ( maxhits ? maxhits : 999999999 ) )
         {
            extern void LoadVariables();
            LoadVariables();
            print( n, buf );
            printf( buf );
            engine.bytesOut += strlen( buf );
            n++;
         }
         else
         {
            *next = i;
            break;
         }
      }
   }
   end:
      gettimeofday( &finish, &tz );
      engine.seconds = finish.tv_sec - start.tv_sec;
      return n;
}

/*---------------------------------------------------------------------------*/

void dbNextAnchor( char *url, int first, int maxhits, entry entries[], int m )
{
   int i;
   printf( "<A HREF=\"%s?first:%d+maxhits:%d", url, first, maxhits );

   for( i = 0; i <= m; i++ )
   {
      if( strcmp( entries[i].name, "" ) && strcmp( entries[i].val, "" ) )
      {
         printf( "+%s:%s", entries[i].name, entries[i].val );
      }
   }
   printf( "\">Next %d records</A>%c", maxhits, 10 );
}

/*---------------------------------------------------------------------------*/
