#
#  article.awk  Ver 1.0
#
#  <C> Copyright 1995 Symbiotic Solutions
#  Authors:  Emanuel Noik
#
#  This code may look like awk but it's actually gawk!
#
#-------------------------------------------------------------------------------

BEGIN {
   FS="|";		# field separator
   n = 0;		# number of hits

   print "<html><header>";
   print "<title>Art of Investment Article Search Results</title>"
   print "</header><body>"
   print "<h2>Query Results</h2><hr size=\"2\">"

   dbInit();		# initialize database package
   dbMaxHits=10;	# set default maximum hits (temporary)

   dbField(1,  "L", "article/author.txt" )	# author
   dbField(2,  "D", "" )			# date
   dbField(3,  "S", "" )			# title
   dbField(4,  "M", "article/subjects.txt" )	# subjects
   dbField(5,  "S", "" )			# URL
   dbField(6,  "L", "article/affil.txt" )	# affiliation

   dbArgs();
}

{
   if( NR < dbOffset ) next;	# skip records

   if( myFilter() )
   {
      if( n == dbMaxHits )		# only show dbMaxHits
      {
         dbMoreHits( "/cgi-bin/aofi" );
         exit;
      }

      print substr($2,1,4) " " substr($2,5,2) " " substr($2,7,2) " "
      print "<a href=\"http://www.aofi.com/articles/" $5 "\"> "
      print "<i>" $3 "</i></a>, "
      print ml[1,$1]
      if( $6 != 0 ) print ", " ml[6,$6]
      print "<br>"
      n++;
   }
}

function myFilter() {
   return ( dbFilterI(1) > -1 && \
            dbFilterI(2) > -1 && \
            dbFilterI(3) > -1 && \
            dbFilterI(4) > -1 \
          ) ? 1 : 0;
}

END {
   if( dbErr )
   {
      print "Received bad data from form, your browser may be obsolete!";
   }
   else
   {
      print "<hr size=\"2\">";
      dbFooter();
      print "</body></html>";
   }
}

#-------------------------------------------------------------------------------
