#
#  bizdir.awk  Ver 1.0
#
#  <C> Copyright 1995 Symbiotic Solutions
#  Authors:  Emanuel Noik
#
#  This code may look like awk but it's actually gawk!
#
#-------------------------------------------------------------------------------

BEGIN {
   FS="|";		# field separator
   n = 0;		# number of hits

   print "<html><header>";
   print "<title>All Canada Business Registry - Search Results</title>";
   print "</header>";
   print "<body bgcolor=\"FFFFE8\">";
   print "<center><img src=\"/db/bizdir/acbr.gif\"></center>";
   print "<h2>Search Results</h2><hr>";

   dbInit();		# initialize database package
   dbMaxHits=5;		# set default maximum hits (temporary)

   dbField(1,  "S", "", "" )	# garbage?
   dbField(2,  "S", "", "" )	# name
   dbField(3,  "S", "", "" )	# street
   dbField(4,  "S", "", "" )	# city
   dbField(5,  "L", "", "" )	# prov
   dbField(6,  "S", "", "" )	# postal
   dbField(7,  "S", "", "" )	# tel
   dbField(8,  "S", "", "" )	# code
   dbField(9,  "S", "", "" )	# date
   dbField(10, "S", "", "" )	# edition
   dbField(11, "M", "", "" )	# SIC codes

   dbArgs();		# process form contents
}

#-------------------------------------------------------------------------------

{
   if( NR < dbOffset ) next;	# skip records

   if( n == dbMaxHits )		# only show dbMaxHits
   {
      dbMoreHits( sprintf( "/cgi-bin/bizdir?%s", file ) );
      exit;
   }

   if( myFilter() )		# is current record a Hit?
   {
      printf( "<P>%s, %s, %s, %s, %s {%s}<BR>\n", $2, $3, $4, $5, $6, $11 );
      n++;
   }
}

#-------------------------------------------------------------------------------

function myFilter() {
   return ( dbFilterI(2) > -1 && \
            dbFilterI(3) > -1 && \
            dbFilterI(4) > -1 && \
            dbFilterI(5) > -1 && \
            dbFilterI(6) > -1 && \
            dbFilterI(11) > -1 \
          ) ? 1 : 0;
}

#-------------------------------------------------------------------------------

END {
   if( dbErr )
   {
      print "Received bad data from form, your browser sucks!";
   }
   else
   {
      print "<hr>";
      dbFooter();
   }
   print "</body></html>";
}

#-------------------------------------------------------------------------------
