#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/time.h>

#include "../libweb/webutil.h"
#include "tradesho.h"

/*----------------------------------------------------------------------------*/

static int myFilter( void )
{
   return ( dbFilterI(0) > -1 &&
            dbFilterI(1) > -1 &&
            dbFilterI(2) > -1 &&
            ( dbFilterI(3) + dbFilterI(4) ) > -1 &&
            dbFilterI(5) > -1
          ) ? 1 : 0;
}

/*----------------------------------------------------------------------------*/

#define BF buf+strlen(buf)

static int DumpList( FILE* fp )
{
   char buf[4096];
   int n = 0;
   struct timeval finish, start;
   struct timezone tz;

   dbTotalBIn = 0;
   dbTotalBOut = 0;  
   gettimeofday( &start, &tz );

   while( fgets( buf, 1024, fp ) != 0 )
   {
      (void)dbRecord( buf );
      dbTotalBIn += strlen( buf );
      buf[0] = 0;

      if( myFilter() )
      {
         if( n > 0 ) sprintf( BF, "<hr>%c", 10 );
         LoadVariables();
         sprintf( BF, "<dl>%c", 10 );
         sprintf( BF, "<dt><i><b>Title:</b></i><dd>%s%c", f_title, 10 );
         sprintf( BF, "<dt><i><b>Venue:</b></i><dd>%s%c", f_location, 10 );
         sprintf( BF, "<dt><i><b>Date:</b></i><dd>%s%c", f_date, 10 );
         if( strcmp( f_duration, "0" ) )
            sprintf( BF, "Duration: %s days%c",
            f_duration, 10 );
         sprintf( BF, "<dt><i><b>Contact:</b></i><dd>%c", 10 );
          if( strcmp( f_contact, "" ) )
            sprintf( BF, "%s<br>%c", f_contact, 10 );
          if( strcmp( f_company, "" ) )
            sprintf( BF, "%s<br>%c", f_company, 10 );
          if( strcmp( f_street, "" ) )
            sprintf( BF, "%s<br>%c", f_street, 10 );
          if( strcmp( f_city, "" ) )
            sprintf( BF, "%s ", f_city );
          if( strcmp( f_postal, "" ) )
            sprintf( BF, "%s", f_postal );
          {
            int i = atoi( f_c_country );
            sprintf( BF, "<br>%s<br>%c", countryBits[i], 10 );
          }
          if( strcmp( f_tel, "" ) )
            sprintf( BF, "Tel: %s %s ", f_tel_code, f_tel );
          if( strcmp( f_fax, "" ) )
            sprintf( BF, "Fax: %s %s ", f_tel_code, f_fax );
         sprintf( BF, "</dl>%c", 10 );

         printf( buf );
         dbTotalBOut += strlen( buf );
         n++;
      }
   }
   gettimeofday( &finish, &tz );
   dbTotalSeconds = finish.tv_sec - start.tv_sec;
   return n;
}

/*----------------------------------------------------------------------------*/

static int BuildQuery( entry entries[], int m )
{
   int x, n = 0;

  /*
   *  First, set up schema and initialize query.
   */
   dbSchemaT( fields );
   dbQuery( "0|||0|0|0/0/0 0:0:0|0|0|-1|0||0|0|0|0||||0|||||||" );

  /*
   *  Next, build query using form input values.
   */
   for( x = 0; x <= m; x++ )
   {
      if( strcmp( entries[x].name, "" ) && strcmp( entries[x].val, "" ) )
      {
         if( dbUpdateQuery( entries[x].name, entries[x].val, fields, masks ) )
         {
            n++;
         }
         else
         {
            if( strcmp( entries[x].name, "date_compar" ) == 0 )
               dbSetCompar( "date", entries[x].val, fields );
         }
      }
   }

   return n;
}

/*----------------------------------------------------------------------------*/

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   int m = CGIInit( entries );

   printf( "Content-type: text/html%c%c", 10, 10 );
   printf( "<header>%c", 10 );
   printf( "<title>The Tradeshow Database - Query Results</title>%c", 10 );
   printf( "</header>%c<body background=\"/images/mullins_bg.jpg\">%c",
   10, 10 );
   printf( "<h2>Query Results</h2>%c<hr size=\"2\" noshade>", 10 );

   BuildQuery( entries, m );

   /*if( ! empty_query )*/
   {
      char path[256];
      FILE* fp;
      int n;

      sprintf( path, "%s/%s/lib/shows.txt", ROOT, CLIENT );
      fp = fopen( path, "r" );
      n = DumpList( fp );
      fclose( fp );

      printf( "<p><hr size=\"2\" noshade>%c", 10 );

      printf( "<i>Query generated " );
      printf( "<b>%s</b> hits and took ", CommaNumber(n) );
      printf( "<b>%s</b> seconds to scan ", CommaNumber(dbTotalSeconds) );
      printf( "<b>%s</b> bytes of data and to send ", CommaNumber(dbTotalBIn) );
      printf( "<b>%s</b> bytes of results.</i>%c", CommaNumber(dbTotalBOut),
      10 );

      printf( "</body>%c", 10 );
   }
/*
   else
   {
      printf(
      "You did not select any search criteria.  Please try again.<BR>%c", 10 );
      printf( SIG );
      printf( "</body>%c", 10 );
   }
*/
   return 0;
}

/*----------------------------------------------------------------------------*/
